<?php
/**
 *  xNOVA 
 *   by YamilRH 2023
 *
 * For the full copyright and license information, please view the LICENSE
 *
 * @package xNOVA
 * @author Jan-Otto Kröpke <slaver7@gmail.com>
 * @copyright 2018 Danter14
 * @copyright 2023 Yamil Readigos Hurtado <ireadigos@gmail.com>
 * @licence MIT
 * @version 2.0.0
 * @link https://xnova.cu
 */

  /*
  * A PHP Function which checks if the IP Address specified is a Proxy Server utilising the API provided by https://proxycheck.io
  * This function is covered under an MIT License.
  */

  function proxycheck_function($Visitor_IP) {

    // ------------------------------
    // SETTINGS
    // ------------------------------

    $API_Key = ""; // Proporcione su clave API entre comillas si tiene una
    $VPN = "1"; // Cambie esto a 1 si desea realizar verificaciones de VPN en sus visitantes
    $TLS = "1"; // Cambie esto a 1 para habilitar la seguridad del transporte, aunque TLS es mucho más lento.
    $TAG = "1"; // Cambie esto a 1 para habilitar el etiquetado de sus consultas (se mostrará dentro de su tablero)
    
    // Si desea etiquetar este tráfico con una descripción específica, colóquelo entre comillas.
   // Sin una etiqueta personalizada ingresada debajo, el dominio y la URL de la página se usarán automáticamente en su lugar.
    $Custom_Tag = ""; // Example: $Custom_Tag = "My Forum Signup Page";

    // ------------------------------
    // END OF SETTINGS
    // ------------------------------

    // Setup the correct querying string for the transport security selected.
    if ( $TLS == 1 ) {
      $Transport_Type_String = "https://";
    } else {
      $Transport_Type_String = "http://";
    }
    
    // By default the tag used is your querying domain and the webpage being accessed
    // However you can supply your own descriptive tag or disable tagging altogether above.
    if ( $TAG == 1 && $Custom_Tag == "" ) {
      $Post_Field = "tag=" . $_SERVER['SERVER_NAME'] . $_SERVER['REQUEST_URI'];
    } else if ( $TAG == 1 && $Custom_Tag != "" ) {
      $Post_Field = "tag=" . $Custom_Tag;
    } else {
      $Post_Field = "";
    }
    
    // Performing the API query to proxycheck.io/v2/ using cURL
    $ch = curl_init($Transport_Type_String . 'proxycheck.io/v2/' . $Visitor_IP . '?key=' . $API_Key . '&vpn=' . $VPN);
    
    $curl_options = array(
      CURLOPT_CONNECTTIMEOUT => 30,
      CURLOPT_POST => 1,
      CURLOPT_POSTFIELDS => $Post_Field,
      CURLOPT_RETURNTRANSFER => true
    );
    
    curl_setopt_array($ch, $curl_options);
    $API_JSON_Result = curl_exec($ch);
    curl_close($ch);
    
    // Decode the JSON from our API
    $Decoded_JSON = json_decode($API_JSON_Result);

    // Check if the IP we're testing is a proxy server
    if ( isset($Decoded_JSON->$Visitor_IP->proxy) && $Decoded_JSON->$Visitor_IP->proxy == "yes" ) {

      // A proxy has been detected.
      return true;
      
    } else {
      
      // No proxy has been detected.
      return false;
      
    }
    
  }

?>
